<template>
  <canvas-switcher-menu>
    <canvas-switcher-button
      icon="mdi-chevron-double-left"
      :tooltip="$t('canvas-switcher.tooltip.slide-all-left')"
      @click="slideLeft"
    />
    <canvas-switcher-button
      icon="mdi-minus"
      :tooltip="$t('canvas-switcher.tooltip.slide-all-decrement')"
      @click="decrement"
    />
    <input
      v-if="isSeconds"
      v-model="value"
      class="custom-input"
    >
    <div v-else class="custom-input">
      {{ text }}
    </div>
    <canvas-switcher-button
      icon="mdi-plus"
      :tooltip="$t('canvas-switcher.tooltip.slide-all-increment')"
      @click="increment"
    />
    <canvas-switcher-button
      icon="mdi-chevron-double-right"
      :tooltip="$t('canvas-switcher.tooltip.slide-all-right')"
      @click="slideRight"
    />
  </canvas-switcher-menu>
</template>

<script lang="ts">
import type { Onset, Signature } from '@/data';
import type SynchronizationActions from '@/synchronization-logic/SynchronizationActions';
import {
  Component, Prop, Vue,
} from 'vue-property-decorator';
import type { Increment } from '../toolbars/synchronization/TapBar.vue';
import CanvasSwitcherButton from './CanvasSwitcherButton.vue';
import CanvasSwitcherMenu from './CanvasSwitcherMenu.vue';

@Component({
  components: {
    CanvasSwitcherButton,
    CanvasSwitcherMenu,
  },
})
export default class CanvasSwitcherTranslator extends Vue {
  @Prop({ required: false, type: Boolean, default: false })
  isSeconds!: boolean;

  @Prop({ required: true })
  actions!: SynchronizationActions;

  @Prop({ required: true })
  signature!: Signature;

  value = 0.01;

  text = '';

  currentIncrementsIndex = 0;

  currentSecondIncrementsIndex = 0;

  secondIncrements = [0.01, 0.02, 0.05, 0.1, 0.2, 0.5, 1, 2, 5, 10];

  update() {
    if (this.isSeconds) {
      this.value = this.secondIncrements[this.currentSecondIncrementsIndex];
    } else {
      this.value = this.possibleIncrements[this.currentIncrementsIndex].value as number;
      this.text = this.$t(`tap-bar.slide-${this.possibleIncrements[this.currentIncrementsIndex].text}`).toString();
    }
  }

  mounted() {
    this.update();
  }

  increment() {
    if (this.isSeconds && typeof this.value === 'number') {
      if (this.currentSecondIncrementsIndex < this.secondIncrements.length - 1) {
        this.currentSecondIncrementsIndex += 1;
      }
    } else if (this.currentIncrementsIndex < this.possibleIncrements.length - 1) {
      this.currentIncrementsIndex += 1;
    }
    this.update();
  }

  decrement() {
    if (this.isSeconds && typeof this.value === 'number') {
      if (this.currentSecondIncrementsIndex > 0) {
        this.currentSecondIncrementsIndex -= 1;
      }
    } else if (this.currentIncrementsIndex > 0) {
      this.currentIncrementsIndex -= 1;
    }
    this.update();
  }

  slideLeft() {
    if (this.isSeconds) {
      this.actions.moveAllBySeconds(-this.value);
    } else {
      this.actions.moveAllByMusicalTime(-this.value as Onset);
    }
  }

  slideRight() {
    if (this.isSeconds) {
      this.actions.moveAllBySeconds(this.value);
    } else {
      this.actions.moveAllByMusicalTime(this.value as Onset);
    }
  }

  @Prop()
  possibleIncrements!: Increment[];
}
</script>

<style lang="scss">
.custom-input {
  width: 100px;
  display: flex;
  justify-content: center;
  align-items: center;
  text-align: center;
}
</style>
